import java.io.FileReader;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.FileWriter;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;


public class Engineer {
    public static final String APP_VERSION = "0.4";


    private static final String CONF_FILE_NAME = "ExpTwo.conf";

    
    public static String getConfString(String key) throws FileNotFoundException, IOException {
	String valueStr = null;
	
	BufferedReader reader = new BufferedReader(new FileReader(CONF_FILE_NAME));
	
	String line = reader.readLine();
	while(line != null) {
	    if(line.toUpperCase().startsWith(key)) {
		int eqIndex = line.indexOf("=");
		valueStr = line.substring(eqIndex + 1).trim();
	    }
	    line = reader.readLine();
	}
	reader.close();

	return valueStr;
    }


    public static void writeConfString(String key, String value) throws IOException {
	// Create conf file if it does not exist
	File f = new File(CONF_FILE_NAME);
	if(!f.exists())
	    new FileOutputStream(f).close();
	BufferedReader reader = new BufferedReader(new FileReader(CONF_FILE_NAME));
	
	BufferedWriter writer = new BufferedWriter(new FileWriter(CONF_FILE_NAME + ".tmp"));

	boolean keyFound = false;
	String line = reader.readLine();
	while(line != null) {
	    if(line.toUpperCase().startsWith(key)) {
		{
		    line = key + "=" + value;
		    keyFound = true;
		}
	    }
	    writer.write(line + "\n");
	    line = reader.readLine();
	}
	if(!keyFound)
	    writer.write(key + "=" + value + "\n");
	reader.close();
	writer.flush();
	writer.close();

	File oldFile = new File(CONF_FILE_NAME);
	File newFile = new File(CONF_FILE_NAME + ".tmp");

	oldFile.delete();
	if(oldFile.exists())
	    throw new IOException("Cannot rename: file " + CONF_FILE_NAME + " still exists");
	newFile.renameTo(new File(CONF_FILE_NAME));
    }
}
