import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiUnavailableException;


public class MidiInfo {
    public static void main(String[] args) {
	MidiDevice.Info infos[] = MidiSystem.getMidiDeviceInfo ();

	for(int i=0; i<infos.length; ++i) {
	    
	    try {
		MidiDevice dev = MidiSystem.getMidiDevice(infos[i]);
		
		System.out.println("--- MIDI Device #" + i + " ---");
		System.out.println("Name         : " + infos[i].getName());
		System.out.println("Description  : " + infos[i].getDescription());
		int n = dev.getMaxReceivers();
		System.out.println("Receivers    : " + (n != -1 ? n : "unlimited"));
		n = dev.getMaxTransmitters();
		System.out.println("Transmitters : " + (n != -1 ? n : "unlimited"));
	    }
	    catch(MidiUnavailableException ex) {
		System.out.println("MIDI unavailable.");
	    }
	    
	}
    }  
}
